=== debian/changelog ===
opencpn (1:5.12.4+dfsg-1) unstable; urgency=medium

  * New upstream release
  * Update standards-version to 4.7.2, no changes
  * Verify builds using gcc-15. Closes: #1097517
  * d/patches: Add missing annotations.
  * d/patches: rebased, dropped 6 upstreamed patches:
      - 0007-DataMonitor-Filter-selection-bugfix-4693.patch
      - 0008-Correct-RoutePoint-creation-time-loading-from-dB.-47.patch
      - 0009-data_monitor-Fix-broken-logfile-column-spec-4717.patch
      - 0010-Dashb.-Don-t-resize-a-docked-panel-after-changed-pre.patch
      - 0011-Fix-RangeRingColours-for-Isolated-Marks-4727.patch
      - 0012-OCPNRegion-Fix-uninitialized-variable-FTBFS-on-some-.patch

 -- Alec Leamas <leamas.alec@gmail.com>  Sat, 13 Sep 2025 11:55:29 +0200
