=== debian/watch ===
version=4

# Explicitly prefer .zip until #831370 is fixed in tar.

opts=\
     downloadurlmangle=s|releases/tag|archive/refs/tags|;\
                       s|$|.zip|,\
     dversionmangle=auto,\
     repacksuffix=+dfsg \
https://github.com/OpenCPN/OpenCPN/releases \
releases/tag/(?:Release|v)@ANY_VERSION@
